#define a2v_ObjectMatrix gl_TextureMatrix[0]
#define a2v_ShadowProjMatrix gl_TextureMatrix[2]
#define a2v_ShadowProjTexAdjMatrix gl_TextureMatrix[3]

uniform vec3 a2v_LightVec;

attribute vec2 a2v_Texcoord;
attribute vec3 a2v_Normal;

varying vec2 v2f_Texcoord;
varying vec3 v2f_ShadowInfo;
varying vec3 v2f_Normal;
varying vec3 v2f_LightVec;

void main()
{
	gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
	v2f_Texcoord = a2v_Texcoord;
	
	v2f_Normal = gl_NormalMatrix * a2v_Normal;
	v2f_LightVec = a2v_LightVec;
	
	// Shadow Calculation
	vec4 VertexObjectSpace = a2v_ObjectMatrix * gl_Vertex;
	vec4 Position = a2v_ShadowProjMatrix * VertexObjectSpace;
	v2f_ShadowInfo.z = (1.0-Position.z)*0.5 + 0.004;
	v2f_ShadowInfo.xy = vec2(a2v_ShadowProjTexAdjMatrix * VertexObjectSpace);
}