#define a2v_ObjectMatrix gl_TextureMatrix[0]
#define a2v_ShadowProjMatrix gl_TextureMatrix[2]
#define a2v_ShadowProjTexAdjMatrix gl_TextureMatrix[3]

attribute vec2 a2v_Texcoord;
attribute vec3 a2v_AutumnColor;
attribute vec3 a2v_Fallinfo;
attribute vec3 a2v_FallCenter;
attribute vec2 a2v_FallDirection;
attribute vec2 a2v_Origin;

varying vec2 v2f_Texcoord;
varying vec3 v2f_Color;
varying vec3 v2f_ShadowInfo;

uniform float a2v_Time;

void main()
{
	float time = max(a2v_Time-a2v_Fallinfo.x, 0.0);
	float angle = time*a2v_Fallinfo.y;
	float angle_sin = sin(angle);
	float angle_cos = cos(angle);
	mat2 rotation = mat2(angle_cos, -angle_sin, angle_sin, angle_cos);
	vec3 vertex = vec3(rotation*gl_Vertex.xz, gl_Vertex.y).xzy;
	
	vec3 pos = a2v_FallCenter + vec3(rotation*a2v_Origin, -time*a2v_Fallinfo.z).xzy +
		vertex + vec3(a2v_FallDirection, 0.0).xzy * time;

	gl_Position = gl_ModelViewProjectionMatrix * vec4(pos, 1.0);
	
	v2f_Texcoord = a2v_Texcoord;//(a2v_Texcoord-vec2(0.5,0.5)) * rotation + vec2(0.5, 0.5);
	v2f_Color = a2v_AutumnColor;
	
	// Shadow Calculation
	vec4 VertexObjectSpace = a2v_ObjectMatrix * vec4(pos, 1.0);
	vec4 Position = a2v_ShadowProjMatrix * VertexObjectSpace;
	v2f_ShadowInfo.z = (1.0-Position.z)*0.5 + 0.004;
	v2f_ShadowInfo.xy = vec2(a2v_ShadowProjTexAdjMatrix * VertexObjectSpace);
}