attribute vec3 a2v_Fallinfo;
attribute vec3 a2v_FallCenter;
attribute vec2 a2v_FallDirection;
attribute vec2 a2v_Origin;
attribute vec2 a2v_Texcoord;

varying float v2f_Depth;
varying vec2 v2f_Texcoord;

uniform float a2v_Time;

void main()
{
	float time = max(a2v_Time-a2v_Fallinfo.x, 0.0);
	float angle = time*a2v_Fallinfo.y;
	float angle_sin = sin(angle);
	float angle_cos = cos(angle);
	mat2 rotation = mat2(angle_cos, -angle_sin, angle_sin, angle_cos);
	vec3 vertex = vec3(rotation*gl_Vertex.xz, gl_Vertex.y).xzy;
	
	vec3 pos = a2v_FallCenter + vec3(rotation*a2v_Origin, -time*a2v_Fallinfo.z).xzy +
		vertex + vec3(a2v_FallDirection, 0.0).xzy * time;

	gl_Position = gl_ModelViewProjectionMatrix * vec4(pos, 1.0);
	
	//
	v2f_Depth = (1.0-gl_Position.z)*0.5;
	v2f_Texcoord = a2v_Texcoord;
}