#define a2v_ObjectMatrix gl_TextureMatrix[0]
#define a2v_ShadowProjMatrix gl_TextureMatrix[2]
#define a2v_ShadowProjTexAdjMatrix gl_TextureMatrix[3]

attribute vec2 a2v_Texcoord;
attribute vec3 a2v_Origin;
attribute vec3 a2v_Color;
attribute vec2 a2v_Growinfo;

varying vec2 v2f_Texcoord;
varying vec3 v2f_Color;
varying vec3 v2f_ShadowInfo;

uniform float a2v_Time;

void main()
{
	vec3 pos = a2v_Origin + vec3(gl_Vertex) *
		clamp((a2v_Time-a2v_Growinfo.x) / a2v_Growinfo.y, 0.0, 1.0);

	gl_Position = gl_ModelViewProjectionMatrix * vec4(pos, 1.0);
	v2f_Texcoord = a2v_Texcoord;
	v2f_Color = a2v_Color;
	
	// Shadow Calculation
	vec4 VertexObjectSpace = a2v_ObjectMatrix * vec4(pos, 1.0);
	vec4 Position = a2v_ShadowProjMatrix * VertexObjectSpace;
	v2f_ShadowInfo.z = (1.0-Position.z)*0.5 + 0.004;
	v2f_ShadowInfo.xy = vec2(a2v_ShadowProjTexAdjMatrix * VertexObjectSpace);
}