#define a2v_ObjectMatrix gl_TextureMatrix[0]
#define a2v_ShadowProjMatrix gl_TextureMatrix[2]
#define a2v_ShadowProjTexAdjMatrix gl_TextureMatrix[3]

attribute vec2 a2v_Texcoord;
attribute vec3 a2v_Color;
attribute vec3 a2v_AutumnColor;
attribute vec2 a2v_Timeinfo;

varying vec2 v2f_Texcoord;
varying vec3 v2f_Color;
varying vec3 v2f_ShadowInfo;

uniform float a2v_Time;

void main()
{
	gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
	v2f_Texcoord = a2v_Texcoord;
	
	float x = clamp((a2v_Time - a2v_Timeinfo.x) / a2v_Timeinfo.y, 0.0, 1.0);
	v2f_Color = a2v_Color*(1.0-x) + a2v_AutumnColor*x;
	
	// Shadow Calculation
	vec4 VertexObjectSpace = a2v_ObjectMatrix * gl_Vertex;
	vec4 Position = a2v_ShadowProjMatrix * VertexObjectSpace;
	v2f_ShadowInfo.z = (1.0-Position.z)*0.5 + 0.004;
	v2f_ShadowInfo.xy = vec2(a2v_ShadowProjTexAdjMatrix * VertexObjectSpace);
}