#define a2v_ObjectMatrix gl_TextureMatrix[0]
#define a2v_ShadowProjMatrix gl_TextureMatrix[2]
#define a2v_ShadowProjTexAdjMatrix gl_TextureMatrix[3]
#define a2v_MirrorMatrix gl_TextureMatrix[4]

attribute vec2 a2v_Texcoord;

varying vec2 v2f_Texcoord;
varying vec3 v2f_ShadowInfo;
varying vec4 v2f_MirrorTexcoord;

void main()
{
	gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
	v2f_Texcoord = a2v_Texcoord;
	
	// Shadow Calculation
	vec4 VertexObjectSpace = a2v_ObjectMatrix * gl_Vertex;
	vec4 Position = a2v_ShadowProjMatrix * VertexObjectSpace;
	v2f_ShadowInfo.z = (1.0-Position.z)*0.5 + 0.004;
	v2f_ShadowInfo.xy = vec2(a2v_ShadowProjTexAdjMatrix * VertexObjectSpace);
	
	v2f_MirrorTexcoord = a2v_MirrorMatrix * VertexObjectSpace;
}